<?php

require_once 'base/GepReuniaoEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 *
 * @author  robertomartins
 */
class GepReuniaoEntity extends GepReuniaoEntityBase
{


    /**
     * Gera novo codigo de Reuniao.
     *
     * @param integer $nrorg Numero da Organizacao.
     *
     * @return $codigo integer
     */
    public static function retornaProxNumeroReuniao($nrorg){
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_REUNIAO', 10);
        return $codigo;
    }


    /**
     * Consulta situacao da sala para um determinado periodo de datas.
     *
     * @param integer $nrsala  Numero da Sala.
     * @param string  $dataIni Data de Inicio.
     * @param string  $dataFim Data de Fim.
     * @param integer $nrorg   Numero da Organizacao.
     * @param integer $nrreuniao Numero da reuniao.
     *
     * @return Ambigous <<type>, multitype:, mixed>|boolean
     */
    public static function consultaDadosByPeriodoDeDatas($nrsala, $dataIni, $dataFim, $nrorg, $nrreuniao){
        $situacaoSala = GepReuniao::consultaDadosByPeriodoDeDatas($nrsala, $dataIni, $dataFim, $nrorg, $nrreuniao);
        return $situacaoSala;
    }


    /**     ok
     * Consulta dados de uma reuniao.
     *
     * @param integer $nrreuniao Numero da Sala.
     * @param integer $nrorg     Numero da Organizacao.
     *
     * @return Ambigous <<type>, multitype:, mixed>|boolean
     */
    public static function consultaDadosReuniao($nrreuniao, $nrorg){
        $dados = GepReuniao::consultaDadosReuniao($nrreuniao, $nrorg);

        if ($dados instanceof GepReuniaoEntity) {
            return $dados;
        }

        return false;
    }


    /**
     * Consulta reunioes por sala.
     *
     * @param integer $nrorg Numero da organizacao.
     * @param integer $sala  Numero da sala.
     *
     * @return Ambigous <boolean, NULL, TkModelEntity>|boolean
     */
    public function consultaDadosBySala($nrorg, $sala) {
        $dados = GepReuniao::consultaDadosBySala($nrorg, $sala);

        if (is_array($dados) === true) {
            return $dados;
        }

        return false;
    }


    /**
     * Pesquisa reunioes por periodo.
     *
     * @param integer $nrorg     Numero da organizacao.
     * @param integer $sala      Codigo da sala.
     * @param string  $dt_inicio Data de inicio.
     * @param string  $dt_fim    Data de fim.
     *
     * @return Ambigous <multitype:, TkModelEntity>|boolean
     */
    public static function reunioesByPeriodoSala($nrorg, $sala, $dt_inicio, $dt_fim) {
        $dados = GepReuniao::reunioesByPeriodoSala($nrorg, $sala, $dt_inicio, $dt_fim);
        if (is_array($dados) === true) {
            return $dados;
        }

        return false;
    }


    /**
     * Retorna as reunioes realizadas pelo operador.
     *
     * @param integer $nrorg    Numero da organizacao.
     * @param integer $operador Numero do operador.
     * @param date    $data     Data atual no sistema.
     *
     * @return boolean
     */
    public static function retornaReunioesRealizadasByOperador($nrorg,$operador,date $data){
        $consulta = GepReuniao::consultaReunioesRealizadasByOperador($nrorg, $operador, $data);
        if (is_array($consulta)) {
            return $consulta;
        } else {
            return false;
        }
    }


    /**
     * Metodo para consultar os valores da tela de reuni�o.
     *
     * @return string
     */
    public static function consultaReunioes(){
        $sql = GepReuniao::consultaReunioes();
        return $sql;
    }


}