/* Sistemas Integrados TECNISA

Nome: LOG_DFE_PARAMFORNE

Descrio:

Atualiza a data de ultima atualizao da tabela PARAMFORNE

Atualizado em outra verso:
03/05/2011 - Lucas Gabriel Lage Costa
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, sysusers U
           WHERE O.NAME = 'LOG_DFE_PARAMFORNE' AND
                 TYPE = 'TR' 		              AND
	              U.UID = O.UID                 AND
	              U.NAME = USER)
DROP TRIGGER LOG_DFE_PARAMFORNE
GO

CREATE  TRIGGER LOG_DFE_PARAMFORNE
ON PARAMFORNE
FOR INSERT,UPDATE,DELETE
AS
   DECLARE  @V_USUARIO   VARCHAR(40);
   DECLARE  @V_TIPO      VARCHAR(1);
   DECLARE  @V_ITPESQ    VARCHAR(40);
   DECLARE  @V_DESC      VARCHAR(300);
   DECLARE  @V_DTOPER    DATETIME;


/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE @V_ID_COMANDO            VARCHAR(1);
   DECLARE @V_CDFORNECED_OLD        VARCHAR(21);
   DECLARE @V_NRDIASBLOQNFFOR_OLD   VARCHAR(5);
   DECLARE @V_IDBLQNFRELAFOAF_OLD   VARCHAR(1);
   DECLARE @V_IDOBRIMPXMLNF_OLD     VARCHAR(1);
   DECLARE @V_IDOBRCHAVACESFO_OLD   VARCHAR(1);
   DECLARE @V_IDVERINSFORCHNFE_OLD  VARCHAR(1);
   DECLARE @V_IDSIMPLESNACIONAL_OLD VARCHAR(1);
   DECLARE @V_IMPVENCXML_OLD        VARCHAR(1);

   DECLARE @V_CDFORNECED_NEW        VARCHAR(21);
   DECLARE @V_NRDIASBLOQNFFOR_NEW   VARCHAR(5);
   DECLARE @V_IDBLQNFRELAFOAF_NEW   VARCHAR(1);
   DECLARE @V_IDOBRIMPXMLNF_NEW     VARCHAR(1);
   DECLARE @V_IDOBRCHAVACESFO_NEW   VARCHAR(1);
   DECLARE @V_IDVERINSFORCHNFE_NEW  VARCHAR(1);
   DECLARE @V_IDSIMPLESNACIONAL_NEW VARCHAR(1);
   DECLARE @V_IMPVENCXML_NEW        VARCHAR(1);

BEGIN

   SET @V_DESC     = '';
   SET @V_TIPO     = '0';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');

   DECLARE C_CURSOR CURSOR FOR

      SELECT
         'U' IDCOMANDO,
      DELETED.CDFORNECED,
      DELETED.NRDIASBLOQNFFOR,
      DELETED.IDBLQNFRELAFOAF,
      DELETED.IDOBRIMPXMLNF,
      DELETED.IDOBRCHAVACESFO,
      DELETED.IDVERINSFORCHNFE,
      DELETED.IDSIMPLESNACIONAL,
      DELETED.IMPVENCXML,

      INSERTED.CDFORNECED,
      INSERTED.NRDIASBLOQNFFOR,
      INSERTED.IDBLQNFRELAFOAF,
      INSERTED.IDOBRIMPXMLNF,
      INSERTED.IDOBRCHAVACESFO,
      INSERTED.IDVERINSFORCHNFE,
      INSERTED.IDSIMPLESNACIONAL,
      INSERTED.IMPVENCXML
   FROM
      INSERTED,
      DELETED
   WHERE
       INSERTED.CDFORNECED     = DELETED.CDFORNECED

   UNION ALL

   SELECT
      'I' IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,

      INSERTED.CDFORNECED,
      INSERTED.NRDIASBLOQNFFOR,
      INSERTED.IDBLQNFRELAFOAF,
      INSERTED.IDOBRIMPXMLNF,
      INSERTED.IDOBRCHAVACESFO,
      INSERTED.IDVERINSFORCHNFE,
      INSERTED.IDSIMPLESNACIONAL,
      INSERTED.IMPVENCXML
   FROM
      INSERTED
   WHERE
       CDFORNECED      NOT IN (SELECT  CDFORNECED      FROM DELETED)

   UNION ALL

   SELECT
         'D' IDCOMANDO,
      DELETED.CDFORNECED,
      DELETED.NRDIASBLOQNFFOR,
      DELETED.IDBLQNFRELAFOAF,
      DELETED.IDOBRIMPXMLNF,
      DELETED.IDOBRCHAVACESFO,
      DELETED.IDVERINSFORCHNFE,
      DELETED.IDSIMPLESNACIONAL,
      DELETED.IMPVENCXML,

      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL
   FROM
      DELETED
   WHERE
       CDFORNECED      NOT IN (SELECT  CDFORNECED      FROM INSERTED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDFORNECED_OLD,
                                 @V_NRDIASBLOQNFFOR_OLD,
                                 @V_IDBLQNFRELAFOAF_OLD,
                                 @V_IDOBRIMPXMLNF_OLD,
                                 @V_IDOBRCHAVACESFO_OLD,
                                 @V_IDVERINSFORCHNFE_OLD,
                                 @V_IDSIMPLESNACIONAL_OLD,
                                 @V_IMPVENCXML_OLD,

                                 @V_CDFORNECED_NEW,
                                 @V_NRDIASBLOQNFFOR_NEW,
                                 @V_IDBLQNFRELAFOAF_NEW,
                                 @V_IDOBRIMPXMLNF_NEW,
                                 @V_IDOBRCHAVACESFO_NEW,
                                 @V_IDVERINSFORCHNFE_NEW,
                                 @V_IDSIMPLESNACIONAL_NEW,
                                 @V_IMPVENCXML_NEW;

WHILE (@@FETCH_STATUS = 0) BEGIN

      IF NOT @V_USUARIO IS NULL BEGIN
         IF @V_ID_COMANDO= 'D' /*DELETING*/ BEGIN
            SET @V_TIPO = '3';
            IF @V_CDFORNECED_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Forne=' + @V_CDFORNECED_OLD;
            END;
            IF @V_NRDIASBLOQNFFOR_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' NrBloqNFForne=' + @V_NRDIASBLOQNFFOR_OLD;
            END;
            IF @V_IDBLQNFRELAFOAF_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' BloqFechNFeRelac=' + @V_IDBLQNFRELAFOAF_OLD;
            END;
            IF @V_IDOBRIMPXMLNF_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' ImportXMLNFe=' + @V_IDOBRIMPXMLNF_OLD;
            END;
            IF @V_IDOBRCHAVACESFO_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' ObrigChaveNFe=' + @V_IDOBRCHAVACESFO_OLD;
            END;
            IF @V_IDVERINSFORCHNFE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' VerifCNPJChave=' + @V_IDVERINSFORCHNFE_OLD;
            END;
            IF @V_IDSIMPLESNACIONAL_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' FornOptSimples=' + @V_IDSIMPLESNACIONAL_OLD;
            END;
            IF @V_IMPVENCXML_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' ImpVencXML=' + @V_IMPVENCXML_OLD;
            END;

            SET @V_ITPESQ = @V_CDFORNECED_OLD;
        END
        ELSE BEGIN
       	  IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN

              IF (@V_CDFORNECED_OLD        <> @V_CDFORNECED_NEW)                            OR
                 (ISNULL(@V_NRDIASBLOQNFFOR_OLD, 0) <> ISNULL(@V_NRDIASBLOQNFFOR_NEW, 0))   OR
                 (@V_IDOBRIMPXMLNF_OLD     <> @V_IDOBRIMPXMLNF_NEW)                         OR
                 (@V_IDBLQNFRELAFOAF_OLD   <> @V_IDBLQNFRELAFOAF_NEW)                       OR
                 (@V_IDOBRIMPXMLNF_OLD     <> @V_IDOBRIMPXMLNF_NEW)                         OR
                 (@V_IDOBRCHAVACESFO_OLD   <> @V_IDOBRCHAVACESFO_NEW)                       OR
                 (@V_IDVERINSFORCHNFE_OLD  <> @V_IDVERINSFORCHNFE_NEW)                      OR
                 (@V_IDSIMPLESNACIONAL_OLD <> @V_IDSIMPLESNACIONAL_NEW)                     OR
                 (@V_IMPVENCXML_OLD        <> @V_IMPVENCXML_NEW)                            BEGIN

                 SET  @V_TIPO   = '2';
                 SET  @V_ITPESQ = @V_CDFORNECED_OLD;

              END;
           END
        	  ELSE BEGIN
           		SET @V_TIPO   = '1';
               SET  @V_ITPESQ = @V_CDFORNECED_NEW;
           END;
        END;
      END;

      IF (@V_ID_COMANDO= 'I') OR (@V_ID_COMANDO='U') BEGIN
         IF ISNULL(@V_CDFORNECED_OLD, '!')      <> ISNULL(@V_CDFORNECED_NEW, '!')      BEGIN
            SET @V_DESC = @V_DESC + ' Forne=' + @V_CDFORNECED_NEW;
         END;
         IF ISNULL(@V_NRDIASBLOQNFFOR_OLD, '!') <> ISNULL(@V_NRDIASBLOQNFFOR_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' NrBloqNFForne=' + @V_NRDIASBLOQNFFOR_NEW;
         END;

         IF ISNULL(@V_IDBLQNFRELAFOAF_OLD, '!') <> ISNULL(@V_IDBLQNFRELAFOAF_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' BloqFechNFeRelac=' + @V_IDBLQNFRELAFOAF_NEW;
         END;

         IF ISNULL(@V_IDOBRIMPXMLNF_OLD, '!') <> ISNULL(@V_IDOBRIMPXMLNF_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' ImportXMLNFe=' + @V_IDOBRIMPXMLNF_NEW;
         END;

         IF ISNULL(@V_IDOBRCHAVACESFO_OLD, '!') <> ISNULL(@V_IDOBRCHAVACESFO_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' ObrigChaveNFe=' + @V_IDOBRCHAVACESFO_NEW;
         END;

         IF ISNULL(@V_IDVERINSFORCHNFE_OLD, '!') <> ISNULL(@V_IDVERINSFORCHNFE_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' VerifCNPJChave=' + @V_IDVERINSFORCHNFE_NEW;
         END;

         IF ISNULL(@V_IDSIMPLESNACIONAL_OLD, '!') <> ISNULL(@V_IDSIMPLESNACIONAL_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' FornOptSimples=' + @V_IDSIMPLESNACIONAL_NEW;
         END;

         IF ISNULL(@V_IMPVENCXML_OLD, '!') <> ISNULL(@V_IMPVENCXML_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + ' ImpVencXML=' + @V_IMPVENCXML_NEW;
         END;
      END;

      IF (@V_TIPO <> '0')  BEGIN
         IF NOT @V_DESC IS NULL BEGIN
            EXEC NMUSUARIO @V_USUARIO;
            SET  @V_DTOPER = GETDATE();
            INSERT INTO LOGOPERA
                     ( NMTABELA, DTOPERACAO, NMRESPOPER,
                        IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                     ('PARAMFORNE', @V_DTOPER, @V_USUARIO,
                        @V_TIPO, @V_ITPESQ, @V_DESC);
         END;
      END;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDFORNECED_OLD,
                                 @V_NRDIASBLOQNFFOR_OLD,
                                 @V_IDBLQNFRELAFOAF_OLD,
                                 @V_IDOBRIMPXMLNF_OLD,
                                 @V_IDOBRCHAVACESFO_OLD,
                                 @V_IDVERINSFORCHNFE_OLD,
                                 @V_IDSIMPLESNACIONAL_OLD,
                                 @V_IMPVENCXML_OLD,

                                 @V_CDFORNECED_NEW,
                                 @V_NRDIASBLOQNFFOR_NEW,
                                 @V_IDBLQNFRELAFOAF_NEW,
                                 @V_IDOBRIMPXMLNF_NEW,
                                 @V_IDOBRCHAVACESFO_NEW,
                                 @V_IDVERINSFORCHNFE_NEW,
                                 @V_IDSIMPLESNACIONAL_NEW,
                                 @V_IMPVENCXML_NEW;
   END;

   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_DFE_PARAMFORNE','5.55.XXX';
GO
